use ::thread::Thread;



///
pub struct Scheduler
{
   ///
   has_unlimited_threads: bool,

   ///
   maximum_thread_amount: u64,

   ///
   thread_list: Vec<Thread>
}



impl Scheduler
{
   ///
   pub fn new(num_threads: Option<u64>) -> Scheduler
   {
      let thread_count: u64;
      let unlimited_threads: bool;

      // Check to see if the scheduler will
      // be using unlimited threads.
      match num_threads
      {
         Some(count) =>
         {
            // Set the maximum number of threads to be the desired
            // amount.
            thread_count = count;
            unlimited_threads = false;
         }

         None =>
         {
            // Set that there can be an unlimited amount of threads.
            thread_count = 0;
            unlimited_threads = true;
         }
      }

      // Create the new Scheduler.
      Scheduler
      {
         has_unlimited_threads: unlimited_threads,
         maximum_thread_amount: thread_count,
         thread_list: Vec::new()
      }
   }

   fn create_thread()
   {
   }
}
